<?php
/*
Plugin Name: Dynamic Home Length
Plugin URI: http://wordpress.org/plugins/dynamic-home-length
Description:  Adjust the number of posts per page at the front page based on the total number of characters in the post contents so that the homepage length remains approximately the same.
Version: 1.1
Author: Narin Olankijanan
Author URI: http://dev.coziplace.com
License: GPLv2
*/

function dhl_queries( $query ) {

  if (!is_admin() && $query->is_main_query()){

   $i = get_option('dhl_option') ;
   
   if (!is_numeric($i)) $i = 5000;
   $j = 0;
   global $wpdb;
   $sql = "SELECT post_content FROM $wpdb->posts WHERE post_type='post' AND post_status='publish' order by post_date DESC";
   $posts = $wpdb->get_col($sql);  
   foreach ($posts as $post) {
       $i = $i - strlen(strip_tags($post)); 
       $j = $j + 1;
       if ($i <= 0) break;
    }

    if(is_home()){
      $query->set('posts_per_page', $j);
    }


  }
}

add_action( 'pre_get_posts', 'dhl_queries' );


add_action( 'admin_menu', 'dhl_menu');

function dhl_menu() {
   
         add_options_page( 'Dynamic home length', 'Dynamic home length','manage_options', 'dynamic-home-length', 'dy_menu_page');
}

function dy_menu_page() {
        if (isset($_POST['i'])) {
            update_option('dhl_option', $_POST['i']);
        }
        $i= get_option('dhl_option');
        ?>
        <div class="wrap">
        <?php screen_icon(); ?>
<h2>Dynamic Home Length Plugin</h2>
To control the length of home page, enter the maximum number of characters you wish to see in the home page :
<form action="" method="post">
<input type="text" name="i" value="<? echo $i ?>">
<input name="Submit" type="submit" value="Save Options" />
</form>
</div>
<?php
}


/* EOF */